Structure finfo
    FunName.s
    Args.s
    HelpLine.s
EndStructure
Structure Seeker
    StructureUnion
    b.b
    w.w
    l.l
    EndStructureUnion
EndStructure
NewList allfunctions.finfo()

NewList PureBasicKeyWords.s()
NewList APIKeyWords.s()
NewList ASMKeyWords.s()
NewList BasicKeyWords.s()
NewList SeparatorKey.s()
NewList OperatorKey.s()

ProcedureDLL.s GetPureBasicPath() ; Retourne le dossier d'installation de PureBasic
    path.s = "Applications\PureBasic.exe\shell\open\command"
    If RegOpenKeyEx_(#HKEY_CLASSES_ROOT, path, 0, #KEY_ALL_ACCESS, @Key) = #ERROR_SUCCESS
        indir.s = Space(500)
        insize = 500
        If RegQueryValueEx_(Key, "", 0, 0, @indir.s, @insize) = #ERROR_SUCCESS
            RegCloseKey_(Key)
            indir = RemoveString(indir, "%1", 1)
            indir = RemoveString(indir, Chr(34), 1)
            indir = RTrim(indir)
            path = GetPathPart(indir)
        Else
            RegCloseKey_(Key)
            ProcedureReturn ""
        EndIf
    EndIf
    If Path
        ProcedureReturn Path
    EndIf
EndProcedure

Procedure ChargLib(LibFile$)
    LibName$ = GetFilePart(LibFile$)
    If ReadFile(0, LibFile$)
        LibSize = Lof()
        *LibHeader = AllocateMemory(LibSize)
        ReadData(*LibHeader, LibSize)
        CloseFile(0)
        *LibEnd = *LibHeader + LibSize
        *LHSeeker.Seeker = *LibHeader
        If *LHSeeker\l = 'PURE' And PeekL(*LHSeeker + 8) = 'LIB3' And PeekL(*LHSeeker + 16) = '3BIL'
            *LHSeeker.Seeker = *LibHeader + 20
            While *LHSeeker\b <> 0 : *LHSeeker + 1 : Wend
            *LHSeeker + 2
            If *LHSeeker >= *LibEnd : ProcedureReturn : EndIf
            nDLL = *LHSeeker\b
            If nDLL
                For i = 1 To nDLL
                    *LHSeeker + 1
                    DLL$ + ", " + PeekS(*LHSeeker)
                    *LHSeeker + Len(PeekS(*LHSeeker))
                Next i
                DLL$ = Right(DLL$, Len(DLL$) - 2)
                *LHSeeker + 1
            EndIf
            *LHSeeker + 1
            While *LHSeeker\b <> 0 : *LHSeeker + 1 : Wend
            *LHSeeker + 1
            If *LHSeeker >= *LibEnd : ProcedureReturn : EndIf
            nPL = *LHSeeker\b
            If nPL
                For i = 1 To nPL
                    *LHSeeker + 1
                    nPL$ + ", " + PeekS(*LHSeeker)
                    *LHSeeker + Len(PeekS(*LHSeeker))
                Next i
                nPL$ = Right(nPL$, Len(nPL$) - 2)
            EndIf
            *LHSeeker + 1
            If *LHSeeker >= *LibEnd : ProcedureReturn : EndIf
            While PeekL(*LHSeeker) <> 'PURE' And PeekL(*LHSeeker + 8) <> 'DAT1'
                AddElement(allfunctions())
                allfunctions()\FunName = PeekS(*LHSeeker)
                *LHSeeker + Len(allfunctions()\FunName) + 1
                *LHSeeker + * LHSeeker\b + 5
                While *LHSeeker\b = 0 : *LHSeeker + 1 : Wend
                allfunctions()\Args = ""
                allfunctions()\HelpLine = ""
                If *LHSeeker\b = '('
                    arging = 1
                    While *LHSeeker\b <> 0
                        If *LHSeeker\b = '-'
                            arging = 0
                        EndIf
                        If arging
                            allfunctions()\Args + Chr(*LHSeeker\b)
                        Else
                            allfunctions()\HelpLine + Chr(*LHSeeker\b)
                        EndIf
                        *LHSeeker + 1
                    Wend
                    allfunctions()\Args = LTrim(RTrim(allfunctions()\Args))
                    allfunctions()\HelpLine = LTrim(RTrim(RemoveString(allfunctions()\HelpLine, "- ")))
                    *LHSeeker + 1
                EndIf
            Wend
        EndIf
        FreeMemory(*LibHeader)
    EndIf
    ForEach allfunctions()
        fonctrouve = 0
        fonc$ = allfunctions()\FunName
        ForEach PureBasicKeyWords()
            If PureBasicKeyWords() = fonc$
                fonctouve = 1
            EndIf
        Next
        If fonctrouve = 0 And fonc$ <> ""
            AddElement(PureBasicKeyWords())
            PureBasicKeyWords()=allfunctions()\funname
        EndIf
    Next
    ClearList(allfunctions())
    ProcedureReturn 1
EndProcedure

lib$=GetPureBasicPath()+"PureLibraries\"
If ExamineDirectory(0,lib$,"*.*")
Repeat
i=NextDirectoryEntry()
If i=1
ChargLib(lib$+DirectoryEntryName())
EndIf
Until i=0
i=1
If ExamineDirectory(1,lib$+"UserLibraries\","*.*")
Repeat
i=NextDirectoryEntry()
If i=1
ChargLib(lib$+"UserLibraries\"+DirectoryEntryName())
EndIf
Until i=0
EndIf
EndIf

apifile=ReadFile(#PB_Any,GetPureBasicPath()+"Compilers\APIFunctionListing.txt")
If apifile
ReadString()
Repeat
lig$=ReadString()
If lig$
AddElement(APIKeyWords())
APIKeyWords()=ReplaceString(StringField(lig$,1,"(")," ","")
EndIf
Until Eof(apifile)
CloseFile(apifile)
EndIf

file=ReadFile(#PB_Any,"ImprimPB.prefs")
If file
ReadString()
Repeat
lig$=ReadString()
If Left(lig$,1)<>"["
AddElement(asmKeyWords())
AsmKeyWords()=ReplaceString(StringField(lig$,1,"|")," ","")
EndIf
Until lig$="[MotClBasic]"
Repeat
lig$=ReadString()
If Left(lig$,1)<>"["
AddElement(basicKeyWords())
basicKeyWords()=ReplaceString(lig$," ","")
EndIf
Until lig$="[Oprateur]"
Repeat
lig$=ReadString()
If Left(lig$,1)<>"["
AddElement(OperatorKey())
OperatorKey()=ReplaceString(lig$," ","")
EndIf
Until lig$="[Sparateur]"
Repeat
lig$=ReadString()
If lig$<>""
AddElement(SeparatorKey())
SeparatorKey()=ReplaceString(lig$," ","")
EndIf
Until Eof(file)
CloseFile(file)
EndIf

;-( Keywords )
DataSection
BasicKeywords:
    Data$ "And"

    Data$ "Break"

    Data$ "CallDebugger"
    Data$ "Case"             
    Data$ "CompilerCase"
    Data$ "CompilerDefault"
    Data$ "CompilerElse"     
    Data$ "CompilerEndIf"  
    Data$ "CompilerEndSelect"
    Data$ "CompilerIf"   ;10    
    Data$ "CompilerSelect" 
    Data$ "Continue"         

    Data$ "Data"           
    Data$ "DataSection"
    Data$ "Debug"         
    Data$ "DebugLevel"  
    Data$ "Declare"        
    Data$ "DeclareCDLL"
    Data$ "DeclareDLL"     
    Data$ "Default"        ;20
    Data$ "DefType"      
    Data$ "Dim"            
    Data$ "DisableDebugger"

    Data$ "Else"              
    Data$ "ElseIf"           
    Data$ "EnableDebugger"
    Data$ "End"               
    Data$ "EndDataSection"
    Data$ "EndEnumeration"
    Data$ "EndIf"             ;30
    Data$ "EndInterface"  
    Data$ "EndProcedure"  
    Data$ "EndSelect"       
    Data$ "EndStructure"  
    Data$ "EndStructureUnion" 
    Data$ "Enumeration"       
    Data$ "Extends"           

    Data$ "FakeReturn"   
    Data$ "For"          
    Data$ "ForEach"   ;40
    Data$ "ForEver"   

    Data$ "Global"
    Data$ "Gosub" 
    Data$ "Goto"  

    Data$ "If"      
    Data$ "IncludeBinary" 
    Data$ "IncludeFile" 
    Data$ "IncludePath"
    Data$ "Interface" 


    Data$ "NewList" ; 50
    Data$ "Next"

    Data$ "Or"
    Data$ "Procedure"      
    Data$ "ProcedureCDLL" 
    Data$ "ProcedureDLL"   
    Data$ "ProcedureReturn"
    Data$ "Protected"

    Data$ "Read"
    Data$ "Repeat"
    Data$ "Restore" ; 60
    Data$ "Return"

    Data$ "Select"
    Data$ "Shared"
    Data$ "Static"
    Data$ "Step"
    Data$ "Structure"
    Data$ "StructureUnion"
    
    Data$ "To"

    Data$ "Until"

    Data$ "Wend" ; 70
    Data$ "While"

    Data$ "XIncludeFile"


  ;- Keywords - ASM
  ASMKeywords:
    Data$ "AAA"
    Data$ "AAD"
    Data$ "AAM"
    Data$ "AAS"
    Data$ "ADC"
    Data$ "ADD"
    Data$ "AND"
    Data$ "ARPL"
    
    Data$ "BOUND"
    Data$ "BSF"
    Data$ "BSR"
    Data$ "BSWAP"
    Data$ "BT"
    Data$ "BTC"
    Data$ "BTR"
    Data$ "BTS"
    
    Data$ "CALL"
    Data$ "CBW"
    Data$ "CDQ"
    Data$ "CLC"
    Data$ "CLD"
    Data$ "CLI"
    Data$ "CLTS"
    Data$ "CMC"
    Data$ "CMP"
    Data$ "CMPS"
    Data$ "CMPXCHG"
    Data$ "CWD"
    Data$ "CWDE"
    
    Data$ "DAA"
    Data$ "DAS"
    Data$ "DB"
    Data$ "DD"
    Data$ "DEC"
    Data$ "DIV"
    Data$ "DW"
    
    Data$ "ENTER"
    Data$ "ESC"
    
    Data$ "F2XM1"
    Data$ "FABS"
    Data$ "FADD"
    Data$ "FCHS"
    Data$ "FCLEX"
    Data$ "FCOM"
    Data$ "FDIV"
    Data$ "FDIVR"
    Data$ "FFREE"
    Data$ "FINCSTP"
    Data$ "FINIT"
    Data$ "FLD"
    Data$ "FLD1"
    Data$ "FLDCW"
    Data$ "FMUL"
    Data$ "FNOP"
    Data$ "FPATAN"
    Data$ "FPREM"
    Data$ "FRNDINT"
    Data$ "FSAVE"
    Data$ "FSCALE"
    Data$ "FSETPM"
    Data$ "FSIN"
    Data$ "FSQRT"
    Data$ "FST"
    Data$ "FSTENV"
    Data$ "FSTSW"
    Data$ "FSUB"
    Data$ "FSUBR"
    Data$ "FTST"
    Data$ "FUCOM"
    Data$ "FWAIT"
    Data$ "FXAM"
    Data$ "FXCH"
    Data$ "FXTRACT"
    Data$ "FYL2X"
    Data$ "FYL2XP1"
    
    Data$ "HLT"
    
    Data$ "IDIV"
    Data$ "IMUL"
    Data$ "IN"
    Data$ "INC"
    Data$ "INS"
    Data$ "INT"
    Data$ "INTO"
    Data$ "INVLPG"
    Data$ "IRET"
    Data$ "IRETD"
    
    Data$ "JA"
    Data$ "JAE"
    Data$ "JB"
    Data$ "JBE"
    Data$ "JC"
    Data$ "JCXZ"
    Data$ "JE"
    Data$ "JECXZ"
    Data$ "JG"
    Data$ "JGE"
    Data$ "JL"
    Data$ "JLE"
    Data$ "JMP"
    Data$ "JNA"
    Data$ "JNAE"
    Data$ "JNB"
    Data$ "JNBE"
    Data$ "JNC"
    Data$ "JNE"
    Data$ "JNG"
    Data$ "JNGE"
    Data$ "JNL"
    Data$ "JNLE"
    Data$ "JNO"
    Data$ "JNP"
    Data$ "JNS"
    Data$ "JNZ"
    Data$ "JO"
    Data$ "JP"
    Data$ "JPE"
    Data$ "JPO"
    Data$ "JS"
    Data$ "JZ"
    
    Data$ "LAHF"
    Data$ "LAR"
    Data$ "LDS"
    Data$ "LEA"
    Data$ "LEAVE"
    Data$ "LES"
    Data$ "LFS"
    Data$ "LGDT"
    Data$ "LGS"
    Data$ "LIDT"
    Data$ "LLDT"
    Data$ "LMSW"
    Data$ "LOCK"
    Data$ "LODS"
    Data$ "LODSB"
    Data$ "LODSW"
    Data$ "LODSD"
    Data$ "LOOP"
    Data$ "LOOPE"
    Data$ "LOOPNE"
    Data$ "LOOPNZ"
    Data$ "LOOPZ"
    Data$ "LSL"
    Data$ "LSS"
    Data$ "LTR"
    
    Data$ "MOV"
    Data$ "MOVS"
    Data$ "MOVSX"
    Data$ "MOVZX"
    Data$ "MUL"
    
    Data$ "NEG"
    Data$ "NOP"
    Data$ "NOT"
    
    Data$ "OR"
    Data$ "OUT"
    Data$ "OUTS"
    
    Data$ "POP"
    Data$ "POPA"
    Data$ "POPAD"
    Data$ "POPF"
    Data$ "POPFD"
    Data$ "PUSH"
    Data$ "PUSHA"
    Data$ "PUSHAD"
    Data$ "PUSHF"
    Data$ "PUSHFD"
    
    Data$ "RCL"
    Data$ "RCR"
    Data$ "REP"
    Data$ "REPE"
    Data$ "REPNE"
    Data$ "REPNZ"
    Data$ "REPZ"
    Data$ "RET"
    Data$ "RETF"
    Data$ "ROL"
    Data$ "ROR"
    
    Data$ "SAHF"
    Data$ "SAL"
    Data$ "SAR"
    Data$ "SBB"
    Data$ "SCAS"
    Data$ "SETAE"
    Data$ "SETB"
    Data$ "SETBE"
    Data$ "SETC"
    Data$ "SETE"
    Data$ "SETG"
    Data$ "SETGE"
    Data$ "SETL"
    Data$ "SETLE"
    Data$ "SETNA"
    Data$ "SETNAE"
    Data$ "SETNB"
    Data$ "SETNC"
    Data$ "SETNE"
    Data$ "SETNG"
    Data$ "SETNGE"
    Data$ "SETNL"
    Data$ "SETNLE"
    Data$ "SETNO"
    Data$ "SETNP"
    Data$ "SETNS"
    Data$ "SETNZ"
    Data$ "SETO"
    Data$ "SETP"
    Data$ "SETPE"
    Data$ "SETPO"
    Data$ "SETS"
    Data$ "SETZ"
    Data$ "SGDT"
    Data$ "SHL"
    Data$ "SHLD"
    Data$ "SHR"
    Data$ "SHRD"
    Data$ "SIDT"
    Data$ "SLDT"
    Data$ "SMSW"
    Data$ "STC"
    Data$ "STD"
    Data$ "STI"
    Data$ "STOS"
    Data$ "STR"
    Data$ "SUB"
    
    Data$ "TEST"
    
    Data$ "VERR"
    Data$ "VERW"
    
    Data$ "WAIT"
    Data$ "WBINVD"
    
    Data$ "XCHG"
    Data$ "XLAT"
    Data$ "XLATB"
    Data$ "XOR"

EndDataSection
;_) 

Procedure affichertout()
; AFFICHE LES COMMANDES Basic, PureBasic, UserLibrairie, Asm , api, operateur, separateur
ForEach APIKeyWords()
Debug APIKeyWords()
Next
ForEach PureBasicKeyWords()
Debug PureBasicKeyWords()
Next
ForEach BasicKeyWords()
Debug BasicKeyWords()
Next
ForEach asmKeyWords()
Debug asmKeyWords()
Next
ForEach OperatorKey()
Debug OperatorKey()
Next
ForEach SeparatorKey()
Debug SeparatorKey()
Next

Debug CountList(APIKeyWords())
Debug CountList(PureBasicKeyWords())
Debug CountList(BasicKeyWords())
Debug CountList(ASMKeyWords())
Debug CountList(OperatorKey())
Debug CountList(SeparatorKey())
EndProcedure


Debug ChargLib("ImprimPB.prefs")
affichertout()

; IDE Options = PureBasic v3.94 (Windows - x86)
; ExecutableFormat=Windows
; EnableXP
; EOF